From 18866dbc888f9bfa0c1685eedc79a65b20bb19ba Mon Sep 17 00:00:00 2001
From: Hirofumi Katayama <katayama.hirofumi.mz@gmail.com>
Date: Thu, 7 Nov 2019 16:27:46 +0900
Subject: [PATCH] user32/tests: Tests for DM_REPOSITION message

Signed-off-by: Hirofumi Katayama <katayama.hirofumi.mz@gmail.com>
---
 dlls/user32/tests/dialog.c | 35 +++++++++++++++++++++++++++++++++++
 1 file changed, 35 insertions(+)

diff --git a/dlls/user32/tests/dialog.c b/dlls/user32/tests/dialog.c
index b72f08816d..a0687726ac 100644
--- a/dlls/user32/tests/dialog.c
+++ b/dlls/user32/tests/dialog.c
@@ -2174,6 +2174,40 @@ static void test_dialog_custom_data(void)
     DialogBoxA(g_hinst, "CUSTOM_TEST_DIALOG", NULL, custom_test_dialog_proc);
 }
 
+static INT_PTR CALLBACK reposition_dialog_proc(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam)
+{
+    RECT rc;
+    SIZE siz;
+
+    if (msg == WM_INITDIALOG)
+    {
+        GetWindowRect(hdlg, &rc);
+        siz.cx = rc.right - rc.left;
+        siz.cy = rc.bottom - rc.top;
+
+        MoveWindow(hdlg, -100, -100, siz.cx, siz.cy, TRUE);
+
+        GetWindowRect(hdlg, &rc);
+        ok(rc.left == -100, "rc.left was %ld\n", rc.left);
+        ok(rc.top == -100, "rc.top was %ld\n", rc.top);
+
+        SendMessage(hdlg, DM_REPOSITION, 0, 0);
+
+        GetWindowRect(hdlg, &rc);
+        ok(rc.left == 0, "rc.left was %ld\n", rc.left);
+        ok(rc.top == 0, "rc.top was %ld\n", rc.top);
+
+        EndDialog(hdlg, 0);
+    }
+
+    return FALSE;
+}
+
+static void test_DM_REPOSITION(void)
+{
+    DialogBoxA(g_hinst, "CUSTOM_TEST_DIALOG", NULL, reposition_dialog_proc);
+}
+
 START_TEST(dialog)
 {
     g_hinst = GetModuleHandleA (0);
@@ -2193,4 +2227,5 @@ START_TEST(dialog)
     test_SaveRestoreFocus();
     test_timer_message();
     test_MessageBox();
+    test_DM_REPOSITION();
 }
-- 
2.23.0

